#!/bin/bash

API_KEY='<<PUT YOUR API KEY HERE>>'
WORK_DIR='/tmp'
LIST_TEMP_FILE='social4.ip.list'

IPSET_NAME_1='SOCIAL-IP4'
IPSET_NAME_2='SOCIAL-IP4-LOADING'

LIST_URL="https://cyberfilter.ru/api/list/?apiKey=$API_KEY&type=social4.ip&output=text&format=ipset&name=$IPSET_NAME_2"

#ZABBIX_SENDER='zabbix_sender -c /etc/zabbix/zabbix_agentd.conf'

if [[ -n "$ZABBIX_SENDER" ]]; then
    START_TIME=`date +%s`
    $ZABBIX_SENDER -k cf_sync_social_ip4_start -o $START_TIME > /dev/null
fi

cd $WORK_DIR

wget -N -q -P $WORK_DIR "$LIST_URL" -O $LIST_TEMP_FILE
if [ $? != 0 ]; then
    echo 'ERROR: unable get ip list file.'; exit 1
fi

TEST=`tail -n 2 $LIST_TEMP_FILE | grep END`
if [ $? != 0 ]; then
    echo 'ERROR: unable get ip list file. truncated file received.'; exit 1
fi

ipset flush $IPSET_NAME_2
if [ $? != 0 ]; then
    echo 'ERROR: unable flush ipset'; exit 1
fi

ipset restore -file $LIST_TEMP_FILE
if [ $? != 0 ]; then
    echo 'ERROR: unable load ipset'; exit 1
fi

ipset swap $IPSET_NAME_1 $IPSET_NAME_2
if [ $? != 0 ]; then
    echo 'ERROR: unable swap ipsets'; exit 1
fi

ipset flush $IPSET_NAME_2
if [ $? != 0 ]; then
    echo 'ERROR: unable flush ipset'; exit 1
fi


if [[ -n "$ZABBIX_SENDER" ]]; then
    RECORDS=`cat $LIST_TEMP_FILE | wc -l`
    $ZABBIX_SENDER -k cf_sync_social_ip4_records -o $RECORDS > /dev/null

    STOP_TIME=`date +%s`
    $ZABBIX_SENDER -k cf_sync_social_ip4_stop -o $STOP_TIME > /dev/null

    WORK_TIME=$((STOP_TIME-START_TIME))
    $ZABBIX_SENDER -k cf_sync_social_ip4_time -o $WORK_TIME > /dev/null
fi

exit 0
